/**
* @file __SIGMA_SDK_COMMON.h
* @brief SIGMA SDK ֐
* @date 2019/04/03
*  @par        History
*  - 2019/04/03
*    -# 0.0.0.1VK쐬
*    -# ɑΉ
*/
#pragma once

#ifndef __SIGMA_SDK_COMMON_H_
#define __SIGMA_SDK_COMMON_H_

#include <initguid.h>

//=================================================================================================
// 萔
//=================================================================================================

#define	PAGE_SIZE_CAM	0x8000		// MłőTCY
#define	PAGE_SIZE		0xef00		// MłőTCY
#define	PAGE_SIZE_BIG	0x0000f000	// MłőTCY
#define	BIG_BUFFER		0x00200000	// 2MB

#define	SIZEOF_DATA_IN	(39)	// 
#define	SIZEOF_DATA_OUT	(31)	// 

// [N̊l
#define	MEM_SMALL			(PAGE_SIZE_CAM+16)
#define	MAX_MEM_SIZE		((10*1024*1024) + 1024)

// HRESULT G[rbg
#define	ERRORBIT_FATAL		0x80000000
#define	ERRORBIT_DEVICE		0x20000000

#define	DEV_RESPONSE_OK		0x2001
#define	DEV_RESPONSE_SUMERR	0xA081

//	萔
#define	SGM_SZ_MAX					256				// ̍ő啶
#define	SGM_SZ_MIDDLE				(SGM_SZ_MAX/2)		// 128
#define	SGM_SZ_SHORT				(SGM_SZ_MAX/4)		// 64
#define	SGM_SZ_MINI					(SGM_SZ_MAX/8)		// 32
#define	SGM_SZ_SMALL				8
#define	SGM_SZ_FILE					_MAX_FNAME

#define	SGM_MAX_DIR_EXTRY			256

#define	SGM_MAX_CUSTOM_BRACKET		5

#define	IFD_TYPE_COUNT	12

#define	IFD_TYPESIZE_VOID		0
#define	IFD_TYPESIZE_BYTE		1
#define	IFD_TYPESIZE_ASCII		1
#define	IFD_TYPESIZE_SHORT		2
#define	IFD_TYPESIZE_LONG		4
#define	IFD_TYPESIZE_RATIONAL	8
#define	IFD_TYPESIZE_SBYTE		1
#define	IFD_TYPESIZE_UNDEFINED	1
#define	IFD_TYPESIZE_SSHORT		2
#define	IFD_TYPESIZE_SLONG		4
#define	IFD_TYPESIZE_SRATIONAL	8
#define	IFD_TYPESIZE_FLOAT		4
#define	IFD_TYPESIZE_DOUBLE		8

//=================================================================================================
// 񋓎q
//=================================================================================================

typedef	enum {
	IFD_TYPE_NONE = 0,
	IFD_TYPE_BYTE = 1,
	IFD_TYPE_ASCII,
	IFD_TYPE_SHORT,
	IFD_TYPE_LONG,
	IFD_TYPE_RATIONAL,
	IFD_TYPE_SBYTE,
	IFD_TYPE_UNDEFINED,
	IFD_TYPE_SSHORT,
	IFD_TYPE_SLONG,
	IFD_TYPE_SRATIONAL,
	IFD_TYPE_FLOAT,
	IFD_TYPE_DOUBLE
}	ifdTypeNum;

//=================================================================================================
// \
//=================================================================================================

#pragma pack(1)

typedef	struct	tag_CamStatus {
	short	CameraStatus;
	short	StatusChg;
	DWORD	CaptStatusChg;
}	CamStatus;

typedef	struct	tag_DataGroup1 {
	BYTE	FieldPresent1;
	BYTE	FieldPresent2;
	char	ShutterSpeed;
	char	Aperture;
	char	ProgramShift;
	char	ISOAuto;
	char	ISOSpeed;
	char	ExpCompensation;
	char	ABValue;
	char	ABSetting;
	char	FrameBufferState;
	WORD	MediaFreeSpace;
	char	MediaStatus;
	WORD	CurrentLensFocalLength;
	char	BatteryState;
	char	AbShotRemainNumber;
	char	ExpCompExcludeAB;
	char	AfButtonSetting;
}	DataGroup1;

typedef	struct	tag_DataGroup2 {
	BYTE	FieldPresent1;
	BYTE	FieldPresent2;
	char	DriveMode;
	char	SpecialMode;
	char	ExposureMode;
	char	AEMeteringMode;
	char	AELock;
	char	AFMode;
	char	AFAreaMode;
	char	AFLock;
	char	FlashType;
	char	FlashFire;
	char	FlashMode;
	char	FlashSetting;
	char	FlashExpCompensation;
	char	WhiteBalance;
	char	Resolution;
	char	ImageQuality;
}	DataGroup2;


typedef	struct	tag_DataGroup3 {
	BYTE	FieldPresent1;
	BYTE	FieldPresent2;
	char	Contrast;
	char	Sharpness;
	char	Saturation;
	char	ColorSpace;
	char	ColorMode;
	char	BatteryKind;
	WORD	LensWideFocalLength;
	WORD	LensTeleFocalLength;
	char	AFAuxiliaryLight;
	char	AFBeep;
	char	UPSetting;
	char	ExtendedMode;
	char	AutoRotate;
	char	TimerSound;
	char	RCChannel;
	char	DestinationToSave;
}	DataGroup3;

typedef	struct	tag_CaptStatus {
	char	ImageID;
	char	ImageDBHead;
	char	ImageDBTail;
	WORD	CaptStatus;
	BYTE	DestinationToSave;
}	CaptStatus;

typedef	struct	tag_ClockData {
	char	TimeSecond;
	char	TimeMinute;
	char	TimeHour;
	char	DateDate;
	char	DateMonth;
	char	DateYear;
}	ClockData;

typedef	struct	tag_SnapState {
	char	CaptureMode;
	char	CaptureAmount;
}	SnapState;

typedef	struct	tag_DataGroup4 {
	BYTE	FieldPresent1;
	BYTE	FieldPresent2;
	char	ISOStepMode;
	char	ISOAutoMaxLimit;
	char	ISOAutoMinLimit;
	char	SFDMode;
	char	DCCropMode;
	char	LVMagnify;
	// 
	BYTE	HighSensitivityISOExpansion;
	BYTE	ContinuousShootingSpeed;
	BYTE	HDR;
	BYTE	DNG;
	BYTE	FillLight;
	BYTE	OpticalDistortion;
	BYTE	OpticalAberration;
	BYTE	OpticalDiffraction;
	BYTE	OpticalLightIntensity;
	BYTE	OpticalColorShading;
	BYTE	OpticalColorShadingGet;
	BYTE	ImageStabilization;
	BYTE	ShutterSound;
}	DataGroup4;

typedef	struct	tag_DataGroup5 {
	BYTE	FieldPresent1;
	BYTE	FieldPresent2;

	WORD	IntervalTimerSecond;
	BYTE	IntervalTimerFrame;
	WORD	RestTimerSecond;
	BYTE	RestTimerFrame;

	WORD	ColorTemp;
	char	WBCorrectAB;
	char	WBCorrectGM;
	BYTE	AspectRatio;
	BYTE	FilterEffect;
	BYTE	ToneEffect;
	BYTE	ToneCtrl;
	BYTE	PreviewExposureInMmode;
	BYTE	FocusPeaking;
	BYTE	FaceDetectionAF;
	BYTE	AFautoExpand;
	BYTE	AFautoExpandCancel;
	BYTE	AFSelectPostion;
	BYTE	AFAreaPosX;
	BYTE	AFAreaPosY;
	BYTE	AFAreaSize;
	BYTE	BatteryStatePack1;
	BYTE	BatteryStatePack2;
	BYTE	FaceDetectionState;
	BYTE	EyeFiCardState;
	BYTE	WiFiStateEyeFiCard;
	BYTE	EyeFiFunctionSetting;
	BYTE	AFAuxLight;
}	DataGroup5;

typedef	struct	tag_CamStatus2 {
	DWORD	DataLength;
	DWORD	NumberOfDirectoryEntries;
	struct {
		WORD	Tag_Type;
		WORD	Data_Type;
		DWORD	Count;
		DWORD	Value_Offset;
	} Dir[1];
}	CamStatus2;

typedef	struct	tag_PictFileInfoData2Ex {
	WORD	PictureFormat;
	BYTE	FileExt[4];
	WORD	SizeX;
	WORD	SizeY;
	BYTE	PathName[SGM_SZ_MIDDLE];
	BYTE	FileName[SGM_SZ_MIDDLE];
	DWORD	FileSize;
	DWORD	FileAddress;
}	PictFileInfoData2Ex;

typedef	struct	tag_PictFileExt {
	WORD	FrameNo;
	WORD	TotalFrame;

	DWORD	Offset_FOVi_Header;
	DWORD	Size_FOVi_Header;

	DWORD	Offset_Ext_Header;
	DWORD	Size_Ext_Header;

	DWORD	Offset_SPPA_Section;
	DWORD	Size_SPPA_Section;
}	PictFileExt;

typedef	struct	tag_IFD_TYPE {
	BYTE	ucTypeValue;
	BYTE	ucByteSize;
}	IFD_TYPE;

typedef	struct	tag_RATIONAL {
	ULONG	ulNumerator;
	ULONG	ulDenominator;
}	RATIONAL;

typedef	struct	tag_SRATIONAL {
	LONG	lNumerator;
	LONG	lDenominator;
}	SRATIONAL;

typedef	struct	tag_ImageFileDirectory {
	WORD	wTagId;
	WORD	wType;
	DWORD	dwCount;
	union
	{
		DWORD_PTR	ulData;
		VOID*		lpData;
		CHAR*		lpAscii;
		BYTE*		lpByte;
		USHORT*		lpShort;
		ULONG*		lpLong;
		RATIONAL*	lpRational;
		CHAR*		lpSbyte;
		BYTE*		lpUndefined;
		SHORT*		lpSshort;
		LONG*		lpSlong;
		SRATIONAL*	lpSrational;
		FLOAT*		lpFloat;
		DOUBLE*		lpDouble;
	}	Value;
}	ImageFileDirectory;

typedef	struct	tag_IFDArray {
	DWORD				dwDirectoryCount;
	ImageFileDirectory*	imageFileDirectory;
}	IFDArray;

typedef	IFDArray	CanSetInfo5;

typedef	IFDArray	DataGroupFocus;

typedef	IFDArray	DataGroupMovie;

typedef	IFDArray	APIConfigTag;

typedef	struct	tag_MovieFileInfo {
	BYTE	FileFormat[4];
	DWORD32	FileHandle;
	DWORD64	FileSize;
	BYTE	PathName[SGM_SZ_MIDDLE];
}	MovieFileInfo;

typedef	struct	tag_MovieFileInfoExt {
	BYTE	FileFormat[4];
	DWORD32	FileHandle;
	DWORD64	FileSize;
	BYTE	PathName[SGM_SZ_MIDDLE];
	BYTE	FileName[SGM_SZ_MIDDLE];
}	MovieFileInfoExt;

typedef struct  _SDK_INFO
{
	void					*lpInterface;
	HANDLE					hMultipleOpenSync;
	void					*lpDataIn;
	void					*lpDataOut;
	void					*lpDataInBig;
	void					*lpDataOutBig;
	DWORD					dwDataInSize;
	DWORD					dwDataOutSize;

	DWORD					dwLastSendSize;
	DWORD					dwLastRecvSize;
	BOOL					bLastUseBugBuffer;
	BOOL					bUseBuffer;

	DWORD					dwDataInSizeBig;
	DWORD					dwDataOutSizeBig;
} SDK_INFO, *LPSDK_INFO;

#pragma pack()

static	const	IFD_TYPE	ifdTypeTable[IFD_TYPE_COUNT+1] = {
	{ IFD_TYPE_NONE,		IFD_TYPESIZE_VOID		},
	{ IFD_TYPE_BYTE,		IFD_TYPESIZE_BYTE		},
	{ IFD_TYPE_ASCII,		IFD_TYPESIZE_ASCII		},
	{ IFD_TYPE_SHORT,		IFD_TYPESIZE_SHORT		},
	{ IFD_TYPE_LONG,		IFD_TYPESIZE_LONG		},
	{ IFD_TYPE_RATIONAL,	IFD_TYPESIZE_RATIONAL	},
	{ IFD_TYPE_SBYTE,		IFD_TYPESIZE_SBYTE		},
	{ IFD_TYPE_UNDEFINED,	IFD_TYPESIZE_UNDEFINED	},
	{ IFD_TYPE_SSHORT,		IFD_TYPESIZE_SSHORT		},
	{ IFD_TYPE_SLONG,		IFD_TYPESIZE_SLONG		},
	{ IFD_TYPE_SRATIONAL,	IFD_TYPESIZE_SRATIONAL	},
	{ IFD_TYPE_FLOAT,		IFD_TYPESIZE_FLOAT		},
	{ IFD_TYPE_DOUBLE,		IFD_TYPESIZE_DOUBLE		}
};

#endif	// #ifndef __SIGMA_SDK_COMMON_H_
